Index: branches/releng-11/nanobsd/files/usr/local/etc/monitrc
===================================================================
--- branches/releng-11/nanobsd/files/usr/local/etc/monitrc	(revision 14142)
+++ branches/releng-11/nanobsd/files/usr/local/etc/monitrc	(revision 14143)
@@ -17,5 +17,5 @@
 ## Start Monit in the background (run as a daemon):
 #
-set daemon  30              # check services at 30 seconds intervals
+set daemon  60              # check services at 30 seconds intervals
 #   with start delay 240    # optional: delay the first check by 4-minutes (by
 #                           # default Monit check immediately after Monit start)
@@ -32,5 +32,5 @@
 ## running Monit instance. By default this file is stored in $HOME/.monit.pid
 #
-# set pidfile /var/run/monit.pid
+ set pidfile /var/run/monit.pid
 #
 ## Set the location of the Monit id file which stores the unique id for the
@@ -38,5 +38,5 @@
 ## default the file is placed in $HOME/.monit.id.
 #
-# set idfile /var/.monit.id
+ set idfile /var/.monit.id
 #
 ## Set the location of the Monit state file which saves monitoring states
@@ -46,5 +46,5 @@
 ## state will be lost on reboot which may be convenient in some situations.
 #
-# set statefile /var/.monit.state
+ set statefile /var/.monit.state
 #
 #
@@ -90,7 +90,7 @@
 ## available in the back end filesystem).
 #
-# set eventqueue
-#     basedir /var/monit  # set the base directory where events will be stored
-#     slots 100           # optionally limit the queue size
+ set eventqueue
+     basedir /var/monit  # set the base directory where events will be stored
+     slots 100           # optionally limit the queue size
 #
 #
@@ -181,9 +181,9 @@
 ## repeating the 'group name' statement.
 #
-#  check file apache_bin with path /usr/local/apache/bin/httpd
+  check file apache_bin with path /usr/local/sbin/httpd
 #    if failed checksum and
 #       expect the sum 8f7f419955cefa0b33a2ba316cba3659 then unmonitor
-#    if failed permission 755 then unmonitor
-#    if failed uid root then unmonitor
+    if failed permission 755 then unmonitor
+    if failed uid root then unmonitor
 #    if failed gid root then unmonitor
 #    alert security@foo.bar on {
@@ -192,4 +192,8 @@
 #    group server
 #
+  check file nsd_bin with path /usr/local/sbin/nsd
+    if failed permission 755 then unmonitor
+    if failed uid root then unmonitor
+
 #
 ## Check that a process is running, in this case Apache, and that it respond
@@ -201,20 +205,42 @@
 ## is defined above.
 #
-#  check process apache with pidfile /usr/local/apache/logs/httpd.pid
-#    start program = "/etc/init.d/httpd start" with timeout 60 seconds
-#    stop program  = "/etc/init.d/httpd stop"
+  check process apache with pidfile /var/run/httpd.pid
+    start program = "/usr/local/etc/rc.d/apache24 start" with timeout 60 seconds
+    stop program  = "/usr/local/etc/rc.d/apache24 stop"
 #    if cpu > 60% for 2 cycles then alert
-#    if cpu > 80% for 5 cycles then restart
-#    if totalmem > 200.0 MB for 5 cycles then restart
-#    if children > 250 then restart
-#    if loadavg(5min) greater than 10 for 8 cycles then stop
-#    if failed host www.tildeslash.com port 80 protocol http
-#       and request "/somefile.html"
-#    then restart
+    if cpu > 80% for 5 cycles then restart
+    if totalmem > 200.0 MB for 5 cycles then restart
+    if children > 250 then restart
+    if loadavg(5min) greater than 10 for 8 cycles then stop
+    if failed host localhost port 80 protocol http
+       and request "/index.html"
+    then restart
 #    if failed port 443 protocol https with timeout 15 seconds then restart
 #    if 3 restarts within 5 cycles then unmonitor
-#    depends on apache_bin
+    depends on apache_bin
 #    group server
 #
+
+  check process dhcpd with pidfile /var/run/dhcpd/dhcpd.pid
+    start program = "/usr/local/etc/rc.d/isc-dhcpd start" with timeout 60 seconds
+    stop program  = "/usr/local/etc/rc.d/isc-dhcpd stop"
+
+  check process lvrouted with pidfile /var/run/lvrouted.pid
+   start program = "/usr/local/etc/rc.d/lvrouted start"
+   stop  program = "/usr/local/etc/rc.d/lvrouted stop"
+
+  check process nsd with pidfile /var/run/nsd/nsd.pid
+    start program = "/usr/local/etc/rc.d/nsd start" with timeout 60 seconds
+    stop program  = "/usr/local/etc/rc.d/nsd stop"
+    depends on nsd_bin
+
+  check process ntpd with pidfile /var/run/ntpd.pid
+   start program = "/etc/rc.d/ntpd start"
+   stop  program = "/etc/rc.d/ntpd stop"
+
+  check process unbound with pidfile /etc/local//unbound/unbound.pid
+   start program = "/usr/local/etc/rc.d/unbound start"
+   stop  program = "/usr/local/etc/rc.d/unbound stop"
+
 #
 ## Check filesystem permissions, uid, gid, space and inode usage. Other services,